package ru.ulstu.fc.rule.service;

import org.springframework.stereotype.Service;
import ru.ulstu.fc.rule.model.AddVariableForm;
import ru.ulstu.fc.rule.model.Variable;
import ru.ulstu.fc.rule.repository.VariableRepository;

import java.util.List;

@Service
public class VariableService {
    private final VariableRepository variableRepository;

    public VariableService(VariableRepository variableRepository) {
        this.variableRepository = variableRepository;
    }


    public List<Variable> getVars() {
        return variableRepository.findAll();
    }

    public void save(AddVariableForm addVariableForm) {
        if (addVariableForm.getId() == null) {
            variableRepository.save(new Variable(addVariableForm.getName()));
        } else {
            Variable dbVar = variableRepository.findById(addVariableForm.getId()).orElseThrow(() -> new RuntimeException("Variable not found by id"));
            dbVar.setName(addVariableForm.getName());
            variableRepository.save(dbVar);
        }
    }

    public AddVariableForm getAddVariableFormOrDefault(Integer id) {
        return id == null
                ? new AddVariableForm()
                : new AddVariableForm(variableRepository.findById(id).orElseThrow(() -> new RuntimeException("Var not foubd by id")));
    }
}
